using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ImageSharpApp.AlgProcessor.Forms
{
    partial class GrayHistLocalEqForm : Form
    {
        private bool userChanged = false;
        private GrayHistLocalEqParams pars = null;

        public GrayHistLocalEqParams Params
        {
            get
            {
                return this.pars;
            }
        }

        public GrayHistLocalEqForm(GrayHistLocalEqParams pars)
        {
            InitializeComponent();

            this.pars = pars;

            this.userChanged = false;
            trackBarMaskWidth.Minimum = pars.MaskWidthRange.Min;
            trackBarMaskWidth.Maximum = pars.MaskWidthRange.Max;
            trackBarMaskWidth.Value = pars.MaskWidth;
            trackBarMaskWidth.TickStyle = TickStyle.None;
            numericUpDownMaskWidth.Minimum = pars.MaskWidthRange.Min;
            numericUpDownMaskWidth.Maximum = pars.MaskWidthRange.Max;
            numericUpDownMaskWidth.Value = pars.MaskWidth;
            this.userChanged = true;
        }

        public GrayHistLocalEqForm()
        {
            InitializeComponent();
        }

        private void trackBarMaskWidth_ValueChanged(object sender, EventArgs e)
        {
            if (userChanged)
            {
                userChanged = false;
                int width = trackBarMaskWidth.Value;
                this.pars.MaskWidth = width;
                numericUpDownMaskWidth.Value = Math.Min(this.pars.MaskWidthRange.Max, Math.Max(this.pars.MaskWidthRange.Min, width));
                userChanged = true;
            }
        }

        private void numericUpDownMaskWidth_ValueChanged(object sender, EventArgs e)
        {
            if (userChanged)
            {
                userChanged = false;
                int width = (int)numericUpDownMaskWidth.Value;
                this.pars.MaskWidth = width;
                trackBarMaskWidth.Value = Math.Min(this.pars.MaskWidthRange.Max, Math.Max(this.pars.MaskWidthRange.Min, width));
                userChanged = true;
            }
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;
            this.Dispose();
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
            this.Dispose();
        }
    }
}