using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace ImageSharpApp.AlgProcessor.Forms
{
    partial class SegThresholdingForm : Form
    {
        private bool userChanged = false;
        private SegThreshParams pars = null;

        public SegThreshParams Params
        {
            get
            {
                return this.pars;
            }
        }

        public SegThresholdingForm(SegThreshParams pars)
        {
            InitializeComponent();

            this.pars = pars;

            this.userChanged = false;
            trackBarThresh.Minimum = pars.ThreshRange.Min;
            trackBarThresh.Maximum = pars.ThreshRange.Max;
            trackBarThresh.Value = pars.Threshold;
            trackBarThresh.TickStyle = TickStyle.None;
            numericUpDownThresh.Minimum = pars.ThreshRange.Min;
            numericUpDownThresh.Maximum = pars.ThreshRange.Max;
            numericUpDownThresh.Value = pars.Threshold;
            this.userChanged = true;
        }

        public SegThresholdingForm()
        {
            InitializeComponent();
        }

        private void trackBarThresh_ValueChanged(object sender, EventArgs e)
        {
            if (userChanged)
            {
                userChanged = false;
                byte thresh = (byte)trackBarThresh.Value;
                this.pars.Threshold = thresh;
                numericUpDownThresh.Value = Math.Min(this.pars.ThreshRange.Max, Math.Max(this.pars.ThreshRange.Min, thresh));
                userChanged = true;
            }
        }

        private void numericUpDownThresh_ValueChanged(object sender, EventArgs e)
        {
            if (userChanged)
            {
                userChanged = false;
                byte thresh = (byte)numericUpDownThresh.Value;
                this.pars.Threshold = thresh;
                trackBarThresh.Value = Math.Min(this.pars.ThreshRange.Max, Math.Max(this.pars.ThreshRange.Min, thresh));
                userChanged = true;
            }
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.OK;
            this.Dispose();
        }

        private void buttonCancel_Click(object sender, EventArgs e)
        {
            this.DialogResult = DialogResult.Cancel;
            this.Dispose();
        }
    }
}