using System;
namespace ImageSharpApp
{
    enum IPAlgorithms
    {
        GeoSeamCarving,
        GrayContrastAdapt,
        GrayContrastStretch,
        GrayGammaCorrection,
        GrayLUTApplication,
        GrayFunctionApplication,
        GrayImgInversion,
        GrayHistEqualization,
        GrayHistLocalEqualization,
        GrayHistSpecification,
        SegThresholding,
        SegOtsuThresholding,
        SegADB,
        FilterLinearGauss,
        FilterLinearAdaptiveGauss,
        FilterLinearLowpass,
        FilterLinearHighpass,
        FilterLinearHighboost,
        FilterLinearLaplacian,
        FilterLinearLaplacianSharpen,
        FilterLinearUserDefined,
        FilterNonLinearMedian,
        FilterNonLinearUnsharpen,
        FilterNonLinearISEF,
        FilterNonLinearHighboost,
        FilterNonLinearHighboost2,
        FilterSpectralLaplace,
        FilterSpectralLoG,
        FilterSpectralBandpass,
        FilterSpectralLowpass,
        FilterSpectralHighpass,
        FilterSpectralSmoothBandpass,
        FilterSpectralSmoothLowpass,
        FilterSpectralSmoothHighpass,
        EdgesCanny,
        EdgesShenCastan,
        EdgesMarrHildreth,
        EdgesRoberts,
        EdgesPrewitt,
        EdgesSobel,
        EdgesLaplace
    }

    class IPAlgorithmInfo
    {
        static private IPAlgorithms[] needGrayImg = { 
            IPAlgorithms.GrayContrastAdapt,
            IPAlgorithms.GrayContrastStretch,
            IPAlgorithms.GrayGammaCorrection,
            IPAlgorithms.GrayLUTApplication,
            IPAlgorithms.GrayFunctionApplication,
            IPAlgorithms.GrayImgInversion,
            IPAlgorithms.GrayHistEqualization,
            IPAlgorithms.GrayHistLocalEqualization,
            IPAlgorithms.GrayHistSpecification,
            IPAlgorithms.SegThresholding,
            IPAlgorithms.SegOtsuThresholding,
            IPAlgorithms.SegADB,
            IPAlgorithms.FilterLinearGauss,
            IPAlgorithms.FilterLinearAdaptiveGauss,
            IPAlgorithms.FilterLinearLowpass,
            IPAlgorithms.FilterLinearHighpass,
            IPAlgorithms.FilterLinearHighboost,
            IPAlgorithms.FilterLinearLaplacian,
            IPAlgorithms.FilterLinearLaplacianSharpen,
            IPAlgorithms.FilterLinearUserDefined,
            IPAlgorithms.FilterNonLinearMedian,
            IPAlgorithms.FilterNonLinearUnsharpen,
            IPAlgorithms.FilterNonLinearISEF,
            IPAlgorithms.FilterNonLinearHighboost,
            IPAlgorithms.FilterNonLinearHighboost2,
            IPAlgorithms.FilterSpectralLaplace,
            IPAlgorithms.FilterSpectralLoG,
            IPAlgorithms.FilterSpectralBandpass,
            IPAlgorithms.FilterSpectralLowpass,
            IPAlgorithms.FilterSpectralHighpass,
            IPAlgorithms.FilterSpectralSmoothBandpass,
            IPAlgorithms.FilterSpectralSmoothLowpass,
            IPAlgorithms.FilterSpectralSmoothHighpass,
            IPAlgorithms.EdgesCanny,
            IPAlgorithms.EdgesShenCastan,
            IPAlgorithms.EdgesMarrHildreth,
            IPAlgorithms.EdgesRoberts,
            IPAlgorithms.EdgesPrewitt,
            IPAlgorithms.EdgesSobel,
            IPAlgorithms.EdgesLaplace
        };

        public static IPAlgorithms[] NeedGrayImg
        {
            get
            {
                return needGrayImg;
            }
        }

        public static bool NeedsGrayImg(IPAlgorithms algo)
        {
            return (Array.IndexOf(needGrayImg, algo) != -1);
        }
    }
}